Package com.saxonica.ee.trans

## Class ContextItemStaticInfoEE

- java.lang.Object
- - net.sf.saxon.expr.parser.ContextItemStaticInfo
  - - com.saxonica.ee.trans.ContextItemStaticInfoEE

-     public class ContextItemStaticInfoEE
      extends ContextItemStaticInfo

  Saxon-EE version of ContextItemStaticInfo, with extra information used for streamability analysis

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ContextItemStaticInfoEE` | `ABSENT` |
    `static ContextItemStaticInfoEE` | `DEFAULT` | Default information when nothing else is known

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ContextItemStaticInfoEE​(ItemType itemType, boolean maybeUndefined)` | Create a ContextItemStaticInfo
    `ContextItemStaticInfoEE​(ItemType itemType, boolean maybeUndefined, Posture contextItemPosture)` | Create a ContextItemStaticInfo

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AccumulatorFn.Phase` | `getAccumulatorPhase()` | Ask whether the expression is within the select expression or sequence constructor of an accumulator rule, and whether the rule is for the start or end phase
    `Actor` | `getContainer()` |
    `Posture` | `getContextItemPosture()` | Get the context item posture
    `boolean` | `isStrictStreamabilityRules()` |
    `void` | `setAccumulatorPhase​(AccumulatorFn.Phase phase)` | Indicate that the expression is within the select expression or sequence constructor of an accumulator rule, and whether the rule is for the start or end phase
    `void` | `setContainer​(Actor container)` |
    `void` | `setContextPostureGrounded()` | Set streaming posture.
    `void` | `setContextPostureStriding()` | Set streaming posture.
    `void` | `setStrictStreamabilityRules​(boolean strictStreamabilityRules)` |

    - ### Methods inherited from class net.sf.saxon.expr.parser.ContextItemStaticInfo

      `getContextItemUType, getContextSettingExpression, getItemType, isParentless, isPossiblyAbsent, setContextSettingExpression, setParentless`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT

          public static final ContextItemStaticInfoEE DEFAULT

      Default information when nothing else is known

    - #### ABSENT

          public static final ContextItemStaticInfoEE ABSENT

  - ### Constructor Detail

    - #### ContextItemStaticInfoEE

          public ContextItemStaticInfoEE​(ItemType itemType,
                                         boolean maybeUndefined)

      Create a ContextItemStaticInfo
      Parameters:
        `itemType` - the item type of the context item. If the context item is absent, set this to `ErrorType.getInstance()`.
        `maybeUndefined` - set to true if it is possible (or certain) that the context item will be absent.

    - #### ContextItemStaticInfoEE

          public ContextItemStaticInfoEE​(ItemType itemType,
                                         boolean maybeUndefined,
                                         Posture contextItemPosture)

      Create a ContextItemStaticInfo
      Parameters:
        `itemType` - the item type of the context item. If the context item is absent, set this to `ErrorType.getInstance()`.
        `maybeUndefined` - set to true if it is possible (or certain) that the context item will be absent.
        `contextItemPosture` - the context item posture.

  - ### Method Detail

    - #### setContextPostureStriding

          public void setContextPostureStriding()

      Description copied from class: `ContextItemStaticInfo`
      Set streaming posture. The Saxon-HE version of this method has no effect.
      Overrides:
        `setContextPostureStriding` in class `ContextItemStaticInfo`

    - #### setContextPostureGrounded

          public void setContextPostureGrounded()

      Description copied from class: `ContextItemStaticInfo`
      Set streaming posture. The Saxon-HE version of this method has no effect.
      Overrides:
        `setContextPostureGrounded` in class `ContextItemStaticInfo`

    - #### getContainer

          public Actor getContainer()

    - #### setContainer

          public void setContainer​(Actor container)

    - #### getContextItemPosture

          public Posture getContextItemPosture()

      Get the context item posture
      Returns:
        the posture of the expression that sets the context item

    - #### isStrictStreamabilityRules

          public boolean isStrictStreamabilityRules()

      Overrides:
        `isStrictStreamabilityRules` in class `ContextItemStaticInfo`

    - #### setStrictStreamabilityRules

          public void setStrictStreamabilityRules​(boolean strictStreamabilityRules)

    - #### setAccumulatorPhase

          public void setAccumulatorPhase​(AccumulatorFn.Phase phase)

      Indicate that the expression is within the select expression or sequence constructor of an accumulator rule, and whether the rule is for the start or end phase
      Parameters:
        `phase` - indicates whether this is the start or end phase, or null to indicate that the expression is not within an accumulator rule

    - #### getAccumulatorPhase

          public AccumulatorFn.Phase getAccumulatorPhase()

      Ask whether the expression is within the select expression or sequence constructor of an accumulator rule, and whether the rule is for the start or end phase
      Returns:
        whether this is the start or end phase, or null to indicate that the expression is not within an accumulator rule